using System;
using System.Data;
using ShopClassLibrary;
using ShopCommonClassLib;

namespace TestShopConsole
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			//
			// TODO: Add code to start application here
			//

			/*
			User u = new User();

			ShopStatusEnum status = u.Validate("joao", "joao");

			ICustomer c = new Customer();

			DataSet oDS = c.GetByID("joao", "joao", 22);

			foreach(DataRow myRow in oDS.Tables["Customers"].Rows)
			{
				Console.WriteLine(myRow["Name"]);

				//foreach(DataColumn myCol in oDT.Columns)
				//{
				//	Console.WriteLine(myRow[myCol]);
				//}
			}
			*/

//			TestAddShopCustomer();
			TestAddShopSale();
//			TestAddSale();

			Console.ReadLine();
		}

		public static void TestAddCustomer()
		{
			Console.WriteLine("TESTE 'Customer' -->\n\n");

			//
			// criar objecto
			//
			ICustomer oCust = new Customer();

			//
			// invocar mtodo
			//
			ShopStatusEnum status;
			long custID;
			custID = oCust.AddCustomer("joao", "joao", "outro cliente", "outra morada", "telefone", "fax", "email", out status);

			Console.WriteLine("Customer.AddCustomer: status={0}, CustomerID={1}\n", status, custID);		
		}

		public static void TestAddShopCustomer()
		{
			Console.WriteLine("TESTE 'Customer' -->\n\n");

			//
			// criar objecto
			//
			ICustomer oCust = new Customer();

			//
			// invocar mtodo
			//
			ShopStatusEnum status;
			long custID;
			custID = oCust.AddShopCustomer("joao", "joao", "novo cliente", "nova morada", "telefone", "fax", "email", out status);

			Console.WriteLine("Customer.AddCustomer: status={0}, CustomerID={1}\n", status, custID);		
		}

		public static void TestAddSale()
		{
			Console.WriteLine("TESTE 'Sale' -->\n\n");

			//
			// criar objecto
			//
			ISale oSale = new Sale();

			//
			// Criar os SaleDetails
			//
			DataSet dsSaleDetails = oSale.CreateSaleDetails("joao", "joao");

			if (dsSaleDetails == null)
				return;

			//
			// Adicionar registos para 'SaleDetails'
			//

			DataRow dr = null;

			dr = dsSaleDetails.Tables["SaleDetails"].NewRow();
            dr.BeginEdit();
				dr["ProductID"] =  8;
				dr["Quantity"]  = 10;
			dr.EndEdit();
			dsSaleDetails.Tables["SaleDetails"].Rows.Add(dr);

			dr = dsSaleDetails.Tables["SaleDetails"].NewRow();
            dr.BeginEdit();
				dr["ProductID"] = 10;
				dr["Quantity"]  = 15;
			dr.EndEdit();
			dsSaleDetails.Tables["SaleDetails"].Rows.Add(dr);
			
			dr = dsSaleDetails.Tables["SaleDetails"].NewRow();
            dr.BeginEdit();
				dr["ProductID"] = 12;
				dr["Quantity"]  =  8;
			dr.EndEdit();
			dsSaleDetails.Tables["SaleDetails"].Rows.Add(dr);

			DateTime dtDate = new DateTime(2003, 11, 28);

			ShopStatusEnum status = oSale.AddSale("joao", "joao", 25, dtDate, dsSaleDetails);

			Console.WriteLine("Sale.AddSale ==> {0}\n", status);
			Console.WriteLine("\n<-- TESTE 'Sale'\n\n");
		}

		public static void TestAddShopSale()
		{
			Console.WriteLine("TESTE 'Sale' -->\n\n");

			//
			// criar objecto
			//
			ISale oSale = new Sale();

			ShopDataSet dsShop = new ShopDataSet();

			dsShop.SaleDetails.AddSaleDetailsRow( 8, 10, 0, 0);
			dsShop.SaleDetails.AddSaleDetailsRow(10, 15, 0, 0);
			dsShop.SaleDetails.AddSaleDetailsRow(12,  8, 0, 0);

			DateTime dtDate = new DateTime(2003, 11, 29);

			ShopStatusEnum status = oSale.AddShopSale("joao", "joao", 25, dtDate, dsShop);

			Console.WriteLine("Sale.AddSale ==> {0}\n", status);
			Console.WriteLine("\n<-- TESTE 'Sale'\n\n");
		}
	}
}
